#define MIDIC		('M'<<8)
#define MIDIRESET	(MIDIC|01)
#define MIDITIME	(MIDIC|02)
#define MIDITIMERESET	(MIDIC|03)
#define MIDIACTIVE	(MIDIC|04)
#define MIDITHRU	(MIDIC|05)
#define MIDINOACTIVE	(MIDIC|06)
#define MIDISTAT	(MIDIC|07)

#define NUMIRQ 16
#define MIDI_STREAMS 16

struct midi_stat {
	long clock;
	long rqcount;
};

#ifdef _KERNEL

/* bits for midi.flags */
#define ISOPEN		01
/* active sensing is passed on to the reader */
#define ACTSENSE	02
/* when waiting for ACK to come back after a reset */
#define WAITINGFORACK	04

/* There's one of these structures for each open stream */
struct midi {
	int flags;
	int to_id;		/* timeout id */
	time_t clockoffset;
	queue_t *wq;		/* write queue */
	queue_t *rq;		/* read queue */
	int ctlr;		/* MPU controller number (0,1,...) */
};

extern int irq_to_ctlr[];
extern int ctlr_to_irq[];
extern int ctlr_to_data_port[];
extern int ctlr_to_status_port[];
extern int midi_nstr;			/* number of openable streams */
extern int midi_nctlr;			/* number of MPU controllers */
extern struct midi midi_midi[];		/* per device midi structure array */
extern struct midi *midi_end;
extern struct midi *midi_lastopen;

#endif
