/*
 * A test program for reading from /dev/midi.
 * Invoke it, and play something on the MIDI input keyboard.
 * Interrupt to terminate.
 */

#include <stdio.h>
#include <sys/types.h>
#include <sys/fcntl.h>
#include <sys/midi.h>

main(argc,argv)
int argc;
char **argv;
{
	int n, k;
	unsigned char buff[2];
	struct midi_stat ms;
	int fd;
	extern int errno;

	if ( argc > 1 )
		fd = open(argv[1],O_RDONLY );
	else
		fd = open("/dev/midi",O_RDONLY );
	if ( fd < 0 ) {
		fprintf(stderr,"fd=%d, errno=%d\n",fd,errno);
		perror("/dev/midi");
		exit(1);
	}
	/* ioctl(fd,MIDIRESET,0); */
	while ( 1 ) {
		if ( (n=read(fd,buff,sizeof(buff))) > 0 ) {
			ioctl(fd,MIDISTAT,&ms);
			printf("Time=%ld  ",ms.clock);
			printf("qcount=%ld  ",ms.rqcount);
			for ( k=0; k<n; k++ )
				printf("  0x%x",buff[k]);
			printf("\n");
		}
	}
}
